'---------------------------------------------------------------------------------------------------------------
'--------------------------------------Seasonal Unit Root Add-in-----------------------------------
'---------------------------------------------------------------------------------------------------------------
%variable=_this.@name

%regressors="itd"
%info="aic"
!mc=1
!options=0
if @hasoption("itd") then
	%regressors="itd"
	!options=!options+1
endif
if @hasoption("id") then
	%regressors="id"
	!options=!options+1
endif
if @hasoption("it") then
	%regressors="it"
	!options=!options+1
endif
if @hasoption("i") then
	%regressors="i"
	!options=!options+1
endif
if @hasoption("aic") then
	%info="aic"
	!options=!options+1
endif
if @hasoption("schwarz") then
	%info="schwarz"
	!options=!options+1
endif
if @hasoption("hq") then
	%info="hq"
	!options=!options+1
endif
if @hasoption("mc") then
	!mc=1
	!options=!options+1
else
	!mc=0
endif
!maxlag=@val(@equaloption("maxlag"))
!rep=@val(@equaloption("simulations"))

if !maxlag<>NA then
	!options=!options+1
endif
if !rep<>NA then
	!options=!options+1
endif
if !maxlag=NA then
	!maxlag=8
endif
if !rep=NA then
	!rep=1000
endif

if !options=0 then
	%regressors="itd" 'Intercept (i), intercept and seasonal dummies (id), intercept and trend (it), intercept, trend and seasonal dummies (itd)
	%info="schwarz" 'aic schwarz hq
	%maxlag="8"
	%rep="1000"
	scalar structure=1
	scalar info_=1
	scalar m_c=1
	if @uidialog("edit",%variable,"Variable:","radio",structure,"Deterministic regressors","""Intercept, trend and seasonal dummies"" ""Intercept and seasonal dummies"" Intercept-Trend Intercept","list",info_,"Lag length criteria:","Akaike Schwarz Hannan-Quinn","edit",%maxlag,"Maximum lags:","check",m_c,"Simulate critical values by Monte Carlo","edit",%rep,"Number of simulations:","text","Written by: Nicolas Ronderos (2015)","caption","HEGY Seasonal Unit Root")=-1 then
		d info_ m_c structure
		stop
	endif
	if structure=1 then
		%regressors="itd"
	endif
	if structure=2 then
		%regressors="id"
	endif
	if structure=3 then
		%regressors="it"
	endif
	if structure=4 then
		%regressors="i"
	endif
	if info_=1 then
		%info="aic"
	endif
	if info_=2 then
		%info="schwarz"
	endif
	if info_=3 then
		%info="hq"
	endif
	!maxlag=@val(%maxlag)
	!mc=m_c
	!rep=@val(%rep)
endif

if @pagefreq<>"S" then 
	if @pagefreq<>"Q" then
		if @pagefreq<>"M" then
			@uiprompt("The test can only be performed in biannual, quarterly or monthly data.")
			d info_ m_c structure
			stop
		endif
	endif
endif

'-------------------------------------------------Biannual----------------------------------------------

if @pagefreq="S" then
	
%cp=@pagename
smpl @all
genr s1={%variable}+{%variable}(-1)
genr s2=-({%variable}-{%variable}(-1))
series seas
call seas1({%variable},seas)
%lag=""

for !i=0 to !maxlag
	if %regressors="i" then
		if !i>=1 then
			%lag=%lag+"+c("+@str(!i+3)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
		endif
		equation hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3){%lag}
		if %info="hq" then
			vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
		else
			vector(!maxlag+1) info_crit(!i+1)=@{%info}
		endif
			else if %regressors="id" then
				if !i>=1 then
					%lag=%lag+"+c("+@str(!i+4)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
				endif
				equation hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2){%lag}
				if %info="hq" then
					vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
				else
					vector(!maxlag+1) info_crit(!i+1)=@{%info}
				endif
					else if %regressors="it" then
						if !i>=1 then
							%lag=%lag+"+c("+@str(!i+4)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
						endif
						equation hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*@trend{%lag}
						if %info="hq" then
							vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
						else
							vector(!maxlag+1) info_crit(!i+1)=@{%info}
						endif
							else if %regressors="itd" then
								if !i>=1 then
									%lag=%lag+"+c("+@str(!i+5)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
								endif
								equation hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2)+c(5)*@trend{%lag}
								if %info="hq" then
									vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
								else
									vector(!maxlag+1) info_crit(!i+1)=@{%info}
								endif
							endif
					endif
			endif
	endif
next

%lag=""
for !i=0 to !maxlag
	if !i>=1 and %regressors="i" then
		%lag=%lag+"+c("+@str(!i+3)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
	endif
	if !i>=1 and %regressors="id" then
		%lag=%lag+"+c("+@str(!i+4)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
	endif
	if !i>=1 and %regressors="it" then
		%lag=%lag+"+c("+@str(!i+4)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
	endif
	if !i>=1 and %regressors="itd" then
		%lag=%lag+"+c("+@str(!i+5)+")*@d("+%variable+"("+@str(-!i)+"),0,2)"
	endif
	if info_crit(!i+1)=@min(info_crit) then
		exitloop
	endif
next
!s_lag=!i

if %regressors="i" then
	hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3){%lag}
endif
if %regressors="id" then
	hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2){%lag}
endif
if %regressors="it" then
	hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*@trend{%lag}
endif
if %regressors="itd" then
	hegy.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2)+c(5)*@trend{%lag}
endif

scalar obs=@regobs
vector(2) stats(1,1)=@tstats(1)
vector(2) stats(2,1)=@tstats(2)

if !mc=0 then
	string regressors=%regressors
	vector(2) c_v=0
	call cv1(%regressors,obs,c_v)
else
	!obs=@obs({%variable})
	!year=1000+@floor(!obs/2)
	pagecopy(page=simulations) stats
	%cp1=@pagename
	pagestruct(start=1000,end=!year)
	mode quiet
	matrix(!rep,2) statstics
	series seas
	for !i=1 to !rep
		genr x=nrnd
		smpl 1001 @last
		x=x(-2)+nrnd
		smpl @all
		%variable="x"
		call seas1({%variable},seas)
		genr s1={%variable}+{%variable}(-1)
		genr s2=-({%variable}-{%variable}(-1))
		if %regressors="i" then
			equation monte_carlo.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)
		endif
		if %regressors="id" then
			equation monte_carlo.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2)
		endif
		if %regressors="it" then
			equation monte_carlo.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*@trend
		endif
		if %regressors="itd" then
			equation monte_carlo.ls d({%variable},0,2)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)+c(4)*(seas-1/2)+c(5)*@trend
		endif
		statstics(!i,1)=@tstats(1)
		statstics(!i,2)=@tstats(2)
		statusline Monte Carlo Simulations: !i
	next
	pagestruct(end=1000+!rep-2)
	mtos(statstics,group)
	matrix(!rep,2) d1
	matrix(!rep,2) d2
	for !i=1 to 2
		ser0!i.distdata(dtype=cdf) m!i
		if @rows(m!i)<!rep then
			matrix(!rep,4) m_
			matplace(m_,m!i,1,1)
			for !k=@rows(m!i)+1 to !rep
				matrix(!rep,4) m_(!k,1)=m!i(@rows(m!i),1)
				matrix(!rep,4) m_(!k,4)=1
			next
		m!i=m_
		endif
		vector(!rep) s_!i=stats(!i)
		colplace(d1,s_!i,!i)
		colplace(d2,@columnextract(m!i,1),!i)
	next
	matrix d3=@abs(d1-d2)
	matrix(!rep,3) d4
	
	for !i=1 to 2
		colplace(d4,@columnextract(d3,!i),!i)
	next
	colplace(d4,@columnextract(m1,4),3)
	vector min=@cimin(d4)
	
	for !i=1 to 2
		vector(2) probability(!i,1)=d4(min(!i,1),3)
	next
endif

copy {%cp}\hegy hegy
table(9,3) test
setline(test,2)
setline(test,4)
setline(test,7)
test(3,1)="Null"
if !mc=0 then
	test(3,2)="Critical values 5%*"
	setcell(test,8,1,"*Franses and Hobijn (1990)","l")
	setcell(test,9,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
else
	test(3,2)="Simulated P-value*"
	setcell(test,8,1,"*Monte Carlo Simulations: "+@str(!rep),"l")
	setcell(test,9,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
endif
test(3,3)="Statistical"
test(1,1)="Seasonal Unit Root test | HEGY"
setcell(test,5,1,"Nonseasonal unit root (Zero frequency)","l")
setcell(test,6,1,"Seasonal unit root (2 semesters per cycle)","l")

if !mc=0 then
	test(5,2)=c_v(1)
	test(6,2)=c_v(2)
else
	test(5,2)=probability(1,1)
	test(6,2)=probability(2,1)
endif

test(5,3)=stats(1)
test(6,3)=stats(2)

test.setwidth(1) 34
test.setwidth(2) 16
if !mc=1 then
	pageselect {%cp}
endif
%hegytest="hegy_test"
if @isobject("hegy_test") then
	%hegytest=@getnextname(%hegytest)
endif
if !mc=1 then
	pageselect {%cp1}
endif
spool {%hegytest}
{%hegytest}.add test hegy

if !mc=0 then
	d c_v obs regressors s1 s2 test hegy info_crit stats seas
else
	pageselect {%cp}
	copy simulations\{%hegytest} {%hegytest}
	pagedelete simulations
	d hegy info_crit obs s1 s2 stats seas
endif

if !options=0 then
	d info_ m_c structure
endif

endif

'-------------------------------------------------Quarterly----------------------------------------------

if @pagefreq="Q" then

%cp=@pagename
smpl @all
genr s1={%variable}(-1)+{%variable}(-2)+{%variable}(-3)+{%variable}(-4)
genr s2={%variable}(-1)-{%variable}(-2)+{%variable}(-3)-{%variable}(-4)
genr s3={%variable}(-1)-{%variable}(-3)
genr s4=s3(-1)
%lag=""
for !i=0 to !maxlag
	if %regressors="i" then
		if !i>=1 then
			%lag=%lag+"+c("+@str(!i+5)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
		endif
		equation hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5){%lag}
		if %info="hq" then
			vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
		else
			vector(!maxlag+1) info_crit(!i+1)=@{%info}
		endif
			else if %regressors="id" then
				if !i>=1 then
					%lag=%lag+"+c("+@str(!i+8)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
				endif
				equation hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*(@seas(1)-0.25)+c(7)*(@seas(2)-0.25)+c(8)*(@seas(3)-0.25){%lag}
				if %info="hq" then
					vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
				else
					vector(!maxlag+1) info_crit(!i+1)=@{%info}
				endif
					else if %regressors="it" then
						if !i>=1 then
							%lag=%lag+"+c("+@str(!i+6)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
						endif
						equation hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*@trend{%lag}
						if %info="hq" then
							vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
						else
							vector(!maxlag+1) info_crit(!i+1)=@{%info}
						endif
							else if %regressors="itd" then
								if !i>=1 then
									%lag=%lag+"+c("+@str(!i+9)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
								endif
								equation hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*(@seas(1)-0.25)+c(7)*(@seas(2)-0.25)+c(8)*(@seas(3)-0.25)+c(9)*@trend{%lag}
								if %info="hq" then
									vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
								else
									vector(!maxlag+1) info_crit(!i+1)=@{%info}
								endif
							endif
					endif
			endif
	endif
next

%lag=""
for !i=0 to !maxlag
	if !i>=1 and %regressors="i" then
		%lag=%lag+"+c("+@str(!i+5)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
	endif
	if !i>=1 and %regressors="id" then
		%lag=%lag+"+c("+@str(!i+8)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
	endif
	if !i>=1 and %regressors="it" then
		%lag=%lag+"+c("+@str(!i+6)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
	endif
	if !i>=1 and %regressors="itd" then
		%lag=%lag+"+c("+@str(!i+9)+")*@d("+%variable+"("+@str(-!i)+"),0,4)"
	endif
	if info_crit(!i+1)=@min(info_crit) then
		exitloop
	endif
next
!s_lag=!i

if %regressors="i" then
	hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5){%lag}
endif
if %regressors="id" then
	hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*(@seas(1)-0.25)+c(7)*(@seas(2)-0.25)+c(8)*(@seas(3)-0.25){%lag}
endif
if %regressors="it" then
	hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*@trend{%lag}
endif
if %regressors="itd" then
	hegy.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*(@seas(1)-0.25)+c(7)*(@seas(2)-0.25)+c(8)*(@seas(3)-0.25)+c(9)*@trend{%lag}
endif

scalar obs=@regobs
!t1=@tstats(1)
!t2=@tstats(2)
freeze(f_test) hegy.wald c(3)=0, c(4)=0
!f=@val(f_test(6,2))
vector(3) stats(1,1)=!t1
vector(3) stats(2,1)=!t2
vector(3) stats(3,1)=!f

if !mc=0 then
	string regressors=%regressors
	vector(3) c_v=0
	call cv2(%regressors,obs,c_v)
else
	!obs=@obs({%variable})
	!year=1000+@floor(!obs/4)
	pagecopy(page=simulations) stats
	%cp1=@pagename
	pagestruct(start=1000,end=!year)
	mode quiet
	matrix(!rep,3) statstics
	for !i=1 to !rep
		genr x=nrnd
		smpl 1001 @last
		x=x(-4)+nrnd
		smpl @all
		%variable="x"
		genr s1={%variable}(-1)+{%variable}(-2)+{%variable}(-3)+{%variable}(-4)
		genr s2={%variable}(-1)-{%variable}(-2)+{%variable}(-3)-{%variable}(-4)
		genr s3={%variable}(-1)-{%variable}(-3)
		genr s4=s3(-1)
		if %regressors="i" then
			equation monte_carlo.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)
		endif
		if %regressors="id" then
			equation monte_carlo.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*(@seas(1)-0.25)+c(7)*(@seas(2)-0.25)+c(8)*(@seas(3)-0.25)
		endif
		if %regressors="it" then
			equation monte_carlo.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*@trend
		endif
		if %regressors="itd" then
			equation monte_carlo.ls d({%variable},0,4)=c(1)*s1-c(2)*s2+c(3)*s3-c(4)*s4+c(5)+c(6)*@trend+c(7)*(@seas(1)-0.25)+c(8)*(@seas(2)-0.25)+c(9)*(@seas(3)-0.25)
		endif
		statstics(!i,1)=@tstats(1)
		statstics(!i,2)=@tstats(2)
		freeze(f_test) monte_carlo.wald c(3)=0, c(4)=0
		statstics(!i,3)=@val(f_test(6,2))
		d f_test
		statusline Monte Carlo Simulations: !i
	next
	pagestruct(end=1000+!rep-4)
	mtos(statstics,group)
	matrix(!rep,3) d1
	matrix(!rep,3) d2
	for !i=1 to 3
		ser0!i.distdata(dtype=cdf) m!i
		if @rows(m!i)<!rep then
			matrix(!rep,4) m_
			matplace(m_,m!i,1,1)
			for !k=@rows(m!i)+1 to !rep
				matrix(!rep,4) m_(!k,1)=m!i(@rows(m!i),1)
				matrix(!rep,4) m_(!k,4)=1
			next
		m!i=m_
		endif
		vector(!rep) s_!i=stats(!i)
		colplace(d1,s_!i,!i)
		colplace(d2,@columnextract(m!i,1),!i)
	next
	matrix d3=@abs(d1-d2)
	matrix(!rep,4) d4
	
	for !i=1 to 3
		colplace(d4,@columnextract(d3,!i),!i)
	next
	colplace(d4,@columnextract(m1,4),4)
	vector min=@cimin(d4)
	
	for !i=1 to 3
		vector(3) probability(!i,1)=d4(min(!i,1),4)
	next
	vector(3) probability(3,1)=1-probability(3,1)
endif

copy {%cp}\hegy hegy
table(9,3) test
setline(test,2)
setline(test,4)
setline(test,8)
test(3,1)="Null"
if !mc=0 then
	test(3,2)="Critical values 5%*"
	setcell(test,9,1,"*Hyllerberg, Engle, Granger and Yoo (1990)","l")
	setcell(test,10,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
else
	test(3,2)="Simulated P-value*"
	setcell(test,9,1,"*Monte Carlo Simulations: "+@str(!rep),"l")
	setcell(test,10,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
endif
test(3,3)="Statistical"
test(1,1)="Seasonal Unit Root test | HEGY"
setcell(test,5,1,"Nonseasonal unit root (Zero frequency)","l")
setcell(test,6,1,"Seasonal unit root (2 quarters per cycle)","l")
setcell(test,7,1,"Seasonal unit root (4 quarters per cycle)","l")

if !mc=0 then
	test(5,2)=c_v(1)
	test(6,2)=c_v(2)
	test(7,2)=c_v(3)
else
	test(5,2)=probability(1,1)
	test(6,2)=probability(2,1)
	test(7,2)=probability(3,1)
endif

test(5,3)=!t1
test(6,3)=!t2
test(7,3)=!f
test.setwidth(1) 33
test.setwidth(2) 16
if !mc=1 then
	pageselect {%cp}
endif
%hegytest="hegy_test"
if @isobject("hegy_test") then
	%hegytest=@getnextname(%hegytest)
endif
if !mc=1 then
	pageselect {%cp1}
endif
spool {%hegytest}
{%hegytest}.add test hegy

if !mc=0 then
	d c_v f_test obs regressors s1 s2 s3 s4 test hegy info_crit stats
else
	pageselect {%cp}
	copy simulations\{%hegytest} {%hegytest}
	pagedelete simulations
	d f_test hegy info_crit obs s1 s2 s3 s4 stats
endif

if !options=0 then
	d info_ m_c structure
endif

endif

'-------------------------------------------------Monthly----------------------------------------------

if @pagefreq="M" then

%cp=@pagename
smpl @all
series s1 =   {%variable} + {%variable}(-1) + {%variable}(-2) + {%variable}(-3) + {%variable}(-4) + {%variable}(-5) + {%variable}(-6) + {%variable}(-7) + {%variable}(-8) + {%variable}(-9) + {%variable}(-10) + {%variable}(-11)
series s2 = - {%variable} + {%variable}(-1) - {%variable}(-2) + {%variable}(-3) - {%variable}(-4) + {%variable}(-5) - {%variable}(-6) + {%variable}(-7) - {%variable}(-8) + {%variable}(-9) - {%variable}(-10) + {%variable}(-11)
series s3 = - {%variable} + {%variable}(-2) - {%variable}(-4) + {%variable}(-6) - {%variable}(-8) + {%variable}(-10)
series s4 = - {%variable} + @sqrt(3)*{%variable}(-1) - 2*{%variable}(-2) + @sqrt(3)*{%variable}(-3) - {%variable}(-4) + {%variable}(-6) - @sqrt(3)*{%variable}(-7) + 2*{%variable}(-8) - @sqrt(3)*{%variable}(-9) + {%variable}(-10)
series s5 = - {%variable} - @sqrt(3)*{%variable}(-1) - 2*{%variable}(-2) - @sqrt(3)*{%variable}(-3) - {%variable}(-4) + {%variable}(-6) + @sqrt(3)*{%variable}(-7) + 2*{%variable}(-8) + @sqrt(3)*{%variable}(-9) + {%variable}(-10)
series s6 = - {%variable} + {%variable}(-1) - {%variable}(-3) + {%variable}(-4) - {%variable}(-6) + {%variable}(-7) - {%variable}(-9) + {%variable}(-10)
series s7 = - {%variable} - {%variable}(-1) + {%variable}(-3) + {%variable}(-4) - {%variable}(-6) - {%variable}(-7) + {%variable}(-9) + {%variable}(-10)
%lag=""
for !i=0 to !maxlag
	if %regressors="i" then
		if !i>=1 then
			%lag=%lag+"+c("+@str(!i+13)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
		endif
		equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13){%lag}
		if %info="hq" then
			vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
		else
			vector(!maxlag+1) info_crit(!i+1)=@{%info}
		endif
			else if %regressors="id" then
				if !i>=1 then
					%lag=%lag+"+c("+@str(!i+24)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
				endif
					equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12){%lag}
				if %info="hq" then
					vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
				else
					vector(!maxlag+1) info_crit(!i+1)=@{%info}
				endif
					else if %regressors="it" then
						if !i>=1 then
							%lag=%lag+"+c("+@str(!i+14)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
						endif
						equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*@trend{%lag}
						if %info="hq" then
							vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
						else
							vector(!maxlag+1) info_crit(!i+1)=@{%info}
						endif
							else if %regressors="itd" then
								if !i>=1 then
									%lag=%lag+"+c("+@str(!i+25)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
								endif
								equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12)+c(25)*@trend{%lag}
								if %info="hq" then
									vector(!maxlag+1) info_crit(!i+1)=hegy.@hq
								else
									vector(!maxlag+1) info_crit(!i+1)=@{%info}
								endif
							endif
					endif
			endif
	endif
next

%lag=""
for !i=0 to !maxlag
	if !i>=1 and %regressors="i" then
		%lag=%lag+"+c("+@str(!i+13)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
	endif
	if !i>=1 and %regressors="id" then
		%lag=%lag+"+c("+@str(!i+24)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
	endif
	if !i>=1 and %regressors="it" then
		%lag=%lag+"+c("+@str(!i+14)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
	endif
	if !i>=1 and %regressors="itd" then
		%lag=%lag+"+c("+@str(!i+25)+")*@d("+%variable+"("+@str(-!i)+"),0,12)"
	endif
	if info_crit(!i+1)=@min(info_crit) then
		exitloop
	endif
next
!s_lag=!i

if %regressors="i" then
	equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13){%lag}
endif
if %regressors="id" then
	equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12){%lag}
endif
if %regressors="it" then
	equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*@trend{%lag}
endif
if %regressors="itd" then
	equation hegy.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12)+c(25)*@trend{%lag}
endif

scalar obs=@regobs
!t1=@tstats(1)
!t2=@tstats(2)
freeze(f_test1) hegy.wald c(3)=0, c(4)=0
freeze(f_test2) hegy.wald c(5)=0, c(6)=0
freeze(f_test3) hegy.wald c(7)=0, c(8)=0
freeze(f_test4) hegy.wald c(9)=0, c(10)=0
freeze(f_test5) hegy.wald c(11)=0, c(12)=0
vector(7) stats(1,1)=!t1
vector(7) stats(2,1)=!t2
vector(7) stats(3,1)=@val(f_test1(6,2))
vector(7) stats(4,1)=@val(f_test2(6,2))
vector(7) stats(5,1)=@val(f_test3(6,2))
vector(7) stats(6,1)=@val(f_test4(6,2))
vector(7) stats(7,1)=@val(f_test5(6,2))

if !mc=0 then
	string regressors=%regressors
	vector(7) c_v=0
	call cv3(%regressors,obs,c_v)
else
	!obs=@obs({%variable})
	!year=1000+@floor(!obs/12)
	pagecopy(page=simulations) stats
	%cp1=@pagename
	pagestruct(start=1000,end=!year)
	mode quiet
	matrix(!rep,7) statstics
	for !i=1 to !rep
		genr x=nrnd
		smpl 1001 @last
		x=x(-12)+nrnd
		smpl @all
		%variable="x"
		series s1 =   {%variable} + {%variable}(-1) + {%variable}(-2) + {%variable}(-3) + {%variable}(-4) + {%variable}(-5) + {%variable}(-6) + {%variable}(-7) + {%variable}(-8) + {%variable}(-9) + {%variable}(-10) + {%variable}(-11)
		series s2 = - {%variable} + {%variable}(-1) - {%variable}(-2) + {%variable}(-3) - {%variable}(-4) + {%variable}(-5) - {%variable}(-6) + {%variable}(-7) - {%variable}(-8) + {%variable}(-9) - {%variable}(-10) + {%variable}(-11)
		series s3 = - {%variable} + {%variable}(-2) - {%variable}(-4) + {%variable}(-6) - {%variable}(-8) + {%variable}(-10)
		series s4 = - {%variable} + @sqrt(3)*{%variable}(-1) - 2*{%variable}(-2) + @sqrt(3)*{%variable}(-3) - {%variable}(-4) + {%variable}(-6) - @sqrt(3)*{%variable}(-7) + 2*{%variable}(-8) - @sqrt(3)*{%variable}(-9) + {%variable}(-10)
		series s5 = - {%variable} - @sqrt(3)*{%variable}(-1) - 2*{%variable}(-2) - @sqrt(3)*{%variable}(-3) - {%variable}(-4) + {%variable}(-6) + @sqrt(3)*{%variable}(-7) + 2*{%variable}(-8) + @sqrt(3)*{%variable}(-9) + {%variable}(-10)
		series s6 = - {%variable} + {%variable}(-1) - {%variable}(-3) + {%variable}(-4) - {%variable}(-6) + {%variable}(-7) - {%variable}(-9) + {%variable}(-10)
		series s7 = - {%variable} - {%variable}(-1) + {%variable}(-3) + {%variable}(-4) - {%variable}(-6) - {%variable}(-7) + {%variable}(-9) + {%variable}(-10)
		if %regressors="i" then
			equation monte_carlo.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)
		endif
		if %regressors="id" then
			equation monte_carlo.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12)
		endif
		if %regressors="it" then
			equation monte_carlo.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*@trend
		endif
		if %regressors="itd" then
			equation monte_carlo.ls d({%variable},0,12)=c(1)*s1(-1)+c(2)*s2(-1)+c(3)*s3(-1)+c(4)*s3(-2)+c(5)*s4(-1)+c(6)*s4(-2)+c(7)*s5(-1)+c(8)*s5(-2)+c(9)*s6(-1)+c(10)*s6(-2)+c(11)*s7(-1)+c(12)*s7(-2)+c(13)+c(14)*(@seas(1)-1/12)+c(15)*(@seas(2)-1/12)+c(16)*(@seas(3)-1/12)+c(17)*(@seas(4)-1/12)+c(18)*(@seas(5)-1/12)+c(19)*(@seas(6)-1/12)+c(20)*(@seas(7)-1/12)+c(21)*(@seas(8)-1/12)+c(22)*(@seas(9)-1/12)+c(23)*(@seas(10)-1/12)+c(24)*(@seas(11)-1/12)+c(25)*@trend
		endif
		statstics(!i,1)=@tstats(1)
		statstics(!i,2)=@tstats(2)
		freeze(f_test1) monte_carlo.wald c(3)=0, c(4)=0
		freeze(f_test2) monte_carlo.wald c(5)=0, c(6)=0
		freeze(f_test3) monte_carlo.wald c(7)=0, c(8)=0
		freeze(f_test4) monte_carlo.wald c(9)=0, c(10)=0
		freeze(f_test5) monte_carlo.wald c(11)=0, c(12)=0
		statstics(!i,3)=@val(f_test1(6,2))
		statstics(!i,4)=@val(f_test2(6,2))
		statstics(!i,5)=@val(f_test3(6,2))
		statstics(!i,6)=@val(f_test4(6,2))
		statstics(!i,7)=@val(f_test5(6,2))
		d f_test1 f_test2 f_test3 f_test4 f_test5
		statusline Monte Carlo Simulations: !i
	next
	pagestruct(end=1000+!rep-12)
	mtos(statstics,group)
	matrix(!rep,7) d1
	matrix(!rep,7) d2
	for !i=1 to 7
		ser0!i.distdata(dtype=cdf) m!i
		if @rows(m!i)<!rep then
			matrix(!rep,4) m_
			matplace(m_,m!i,1,1)
			for !k=@rows(m!i)+1 to !rep
				matrix(!rep,4) m_(!k,1)=m!i(@rows(m!i),1)
				matrix(!rep,4) m_(!k,4)=1
			next
		m!i=m_
		endif
		vector(!rep) s_!i=stats(!i)
		colplace(d1,s_!i,!i)
		colplace(d2,@columnextract(m!i,1),!i)
	next
	matrix d3=@abs(d1-d2)
	matrix(!rep,8) d4
	
	for !i=1 to 7
		colplace(d4,@columnextract(d3,!i),!i)
	next
	colplace(d4,@columnextract(m1,4),8)
	vector min=@cimin(d4)
	for !i=1 to 7
		vector(7) probability(!i,1)=d4(min(!i,1),8)
	next
	for !i=3 to 7
		vector(7) probability(!i,1)=1-probability(!i,1)
	next
endif

copy {%cp}\hegy hegy
table(13,3) test
setline(test,2)
setline(test,4)
setline(test,12)
test(3,1)="Null"
if !mc=0 then
	test(3,2)="Critical values 5%*"
	setcell(test,13,1,"*Franses and Hobijn (1997)","l")
	setcell(test,14,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
else
	test(3,2)="Simulated P-value*"
	setcell(test,13,1,"*Monte Carlo Simulations: "+@str(!rep),"l")
	setcell(test,14,1,"Selected lag using "+%info+" criteria: "+@str(!s_lag),"l")
endif
test(3,3)="Statistical"
test(1,1)="Seasonal Unit Root test | HEGY"
setcell(test,5,1,"Nonseasonal unit root (Zero frequency)","l")
setcell(test,6,1,"Seasonal unit root (2 months per cycle)","l")
setcell(test,7,1,"Seasonal unit root (4 months per cycle)","l")
setcell(test,8,1,"Seasonal unit root (2.4 months per cycle)","l")
setcell(test,9,1,"Seasonal unit root (12 months per cycle)","l")
setcell(test,10,1,"Seasonal unit root (3 months per cycle)","l")
setcell(test,11,1,"Seasonal unit root (6 months per cycle)","l")

if !mc=0 then
	for !i=1 to 7
		test(4+!i,2)=c_v(!i)
	next
else
	for !i=1 to 7
		test(!i+4,2)=probability(!i,1)
	next
endif

for !i=1 to 7
	test(4+!i,3)=stats(!i)
next

test.setwidth(1) 33
test.setwidth(2) 16
if !mc=1 then
	pageselect {%cp}
endif
%hegytest="hegy_test"
if @isobject("hegy_test") then
	%hegytest=@getnextname(%hegytest)
endif
if !mc=1 then
	pageselect {%cp1}
endif
spool {%hegytest}
{%hegytest}.add test hegy

if !mc=0 then
	d c_v f_test1 f_test2 f_test3 f_test4 f_test5 obs regressors s1 s2 s3 s4 s5 s6 s7 test hegy info_crit stats 
else
	pageselect {%cp}
	copy simulations\{%hegytest} {%hegytest}
	pagedelete simulations
	d f_test1 f_test2 f_test3 f_test4 f_test5 hegy info_crit obs s1 s2 s3 s4 s5 s6 s7 stats
endif

if !options=0 then
	d info_ m_c structure
endif

endif

'---------------------------------------------------------------------------------------------------------------
'-------------------------------------------------Subroutines--------------------------------------------
'---------------------------------------------------------------------------------------------------------------

subroutine local cv1(string regressors,scalar obs,vector cv)
	vector(4) t(1)=20
	vector(4) t(2)=40
	vector(4) t(3)=60
	vector(4) t(4)=80
	vector near=@abs(t-obs)
	scalar min=@min(near)
	for !i=1 to 4
		if near(!i)=min then
			!position=!i
		endif
	next
	
	vector(2) cv
	if !position=1 then
		if regressors="i" then
			cv.fill -2.96, -1.89
		endif
		if regressors="id" then
			cv.fill -2.97, -2.94
		endif
		if regressors="it" then
			cv.fill -3.56, -1.87
		endif
		if regressors="itd" then
			cv.fill -3.61, -2.95
		endif
	endif

	if !position=2 then
		if regressors="i" then
			cv.fill -2.91, -1.92
		endif
		if regressors="id" then
			cv.fill -2.91, -2.90
		endif
		if regressors="it" then
			cv.fill -3.48, -1.92
		endif
		if regressors="itd" then
			cv.fill -3.50, -2.90
		endif
	endif

	if !position=3 then
		if regressors="i" then
			cv.fill -2.88, -1.94
		endif
		if regressors="id" then
			cv.fill -2.88, -2.87
		endif
		if regressors="it" then
			cv.fill -3.46, -1.87
		endif
		if regressors="itd" then
			cv.fill -3.47, -2.87
		endif
	endif

	if !position=4 then
		if regressors="i" then
			cv.fill -2.87, -1.92
		endif
		if regressors="id" then
			cv.fill -2.87, -2.87
		endif
		if regressors="it" then
			cv.fill -3.46, -1.92
		endif
		if regressors="itd" then
			cv.fill -3.46, -2.87
		endif
	endif

endsub

subroutine local seas1(series x, series seas)
	scalar first=@ifirst(x)
	string date=@otod(first)
	series seas=NA
	if @right(date,2)="S1" then
		for !i=first to @obs(x)
			if !i/2=@floor(!i/2) then
				seas(!i)=0
			else
				seas(!i)=1
			endif
		next
	else
		for !i=first to @obs(x)
			if !i/2=@floor(!i/2) then
				seas(!i)=0
			else
				seas(!i)=1
			endif
		next
	endif
endsub

subroutine local cv2(string regressors,scalar obs,vector cv)
	
vector(2) t(1)=100
vector(2) t(2)=200
vector near=@abs(t-obs)
scalar min=@min(near)
for !i=1 to 2
	if near(!i)=min then
		!position=!i
	endif
next

vector(3) cv
if !position=1 then
	if regressors="i" then
		cv.fill -2.88, -1.95, 3.08
	endif
	if regressors="id" then
		cv.fill -3.47, -1.95, 2.96
	endif
	if regressors="it" then
		cv.fill -2.95, -2.94, 6.57
	endif
	if regressors="itd" then
		cv.fill -3.53, -2.94, 6.60
	endif
		else
	if regressors="i" then
		cv.fill -2.87, -1.92, 3.12
	endif
	if regressors="id" then
		cv.fill -3.44, -1.95, 3.07
	endif
	if regressors="it" then
		cv.fill -2.91, -2.89, 6.62
	endif
	if regressors="itd" then
		cv.fill -3.49, -2.91, 6.57
	endif
endif

endsub

subroutine local cv3(string regressors,scalar obs,vector cv)
	
vector(2) t(1)=120
vector(2) t(2)=240
vector(3) t(3)=360
vector(4) t(4)=480
vector near=@abs(t-obs)
scalar min=@min(near)
for !i=1 to 4
	if near(!i)=min then
		!position=!i
	endif
next

vector(7) cv
if !position=1 then
	if regressors="i" then
		cv.fill -2.72, -1.84, 3.01, 2.97, 3.00, 2.98, 3.03
	endif
	if regressors="id" then
		cv.fill -2.67, -2.64, 5.82, 5.80, 5.78, 5.86, 5.86
	endif
	if regressors="it" then
		cv.fill -3.24, -1.83, 2.97, 2.92, 3.00, 2.93, 2.99
	endif
	if regressors="itd" then
		cv.fill -3.19, -2.65, 5.77, 5.77, 5.77, 5.84, 5.82
	endif
endif

if !position=2 then
	if regressors="i" then
		cv.fill -2.79, -1.88, 3.03, 2.99, 3.02, 3.04, 3.06
	endif
	if regressors="id" then
		cv.fill -2.76, -2.76, 6.27, 6.28, 6.21, 6.22, 6.21
	endif
	if regressors="it" then
		cv.fill -3.32, -1.88, 3.01, 2.96, 3.02, 3.02, 3.03
	endif
	if regressors="itd" then
		cv.fill -3.29, -2.76, 6.24, 6.26, 6.18, 6.20, 6.20
	endif
endif

if !position=3 then
	if regressors="i" then
		cv.fill -2.78, -1.89, 3.05, 3.08, 3.14, 3.05, 3.07
	endif
	if regressors="id" then
		cv.fill -2.76, -2.79, 6.35, 6.37, 6.29, 6.36, 6.31
	endif
	if regressors="it" then
		cv.fill -3.35, -1.88, 3.04, 3.08, 3.12, 3.04, 3.05
	endif
	if regressors="itd" then
		cv.fill -3.32, -2.79, 6.35, 6.34, 6.30, 6.37, 6.31
	endif
endif

if !position=4 then
	if regressors="i" then
		cv.fill -2.82, -1.94, 3.07, 3.05, 3.09, 3.09, 3.10
	endif
	if regressors="id" then
		cv.fill -2.81, -2.81, 6.35, 6.48, 6.33, 6.41, 6.47
	endif
	if regressors="it" then
		cv.fill -3.37, -1.94, 3.05, 3.05, 3.08, 3.08, 3.09
	endif
	if regressors="itd" then
		cv.fill -3.35, -2.81, 6.35, 6.48, 6.30, 6.40, 6.46
	endif
endif

endsub


